<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Réponses au sondage</h1>
      <h2 class="has-text-weight-bold is-size-5">« {{ sondage.question }} »</h2>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total de réponses : {{ total }}</h3>
      </div>
      <div class="columns ">
        <div class="column is-one-third">
          <b-input
            v-model="filtreNom"
            placeholder="Rechercher par nom, prénom ou email..."
            rounded
            type="search"
            icon="magnify"
            clearable
          >
          </b-input>
        </div>
        <div class="column">
          <b-autocomplete
            v-model="organismeSearch"
            rounded
            :data="filteredOrganismeArray"
            placeholder="Rechercher par organisme..."
            icon="magnify"
            field="code"
            clearable
            @select="(option) => getUtilisateursOrganisme(option)"
            @input="organismeChange"
          >
            <template #empty>Aucun résultat</template>
            <template slot-scope="org">
              <div class="columns">
                <div class="column  is-2">
                  {{ org.option.code }}
                </div>
                <div class="column">
                  {{ org.option.libelle }}
                </div>
                <div class="column is-2">
                  {{ org.option.libelleTypeOrganisme }}
                </div>
              </div>
            </template>
          </b-autocomplete>
        </div>
      </div>
      <div class="column columns">
        <div class="column is-narrow">
          <b-radio v-model="filtreReponse" class="radioButton is-narrow" native-value="" @input="reload"
            >Toutes les réponses</b-radio
          >
        </div>
        <div v-for="rep in reponsesPossibles" :key="rep" class="column is-narrow">
          <b-radio
            v-model="filtreReponse"
            class="radioButton is-narrow is-uppercase"
            :native-value="rep"
            @input="reload"
            >{{ rep }}</b-radio
          >
        </div>
      </div>
      <div class="columns is-centered">
        <div class="column columns">
          <b-button
            class="column is-one-third"
            type="is-light"
            :icon-right="getIconOrder('pr.code')"
            @click="tri('pr.code')"
            ><b>POSTE</b></b-button
          >
          <b-button
            class="column is-one-third"
            type="is-light"
            :icon-right="getIconOrder('ut.nom')"
            @click="tri('ut.nom')"
            ><b>NOM</b></b-button
          >
          <b-button
            class="column is-one-third"
            type="is-light"
            :icon-right="getIconOrder('ut.prenom')"
            @click="tri('ut.prenom')"
            ><b>PRENOM</b></b-button
          >
        </div>
        <div class="column columns">
          <b-button type="is-light mt-border" :icon-right="getIconOrder('ut.email')" expanded @click="tri('ut.email')"
            ><b>EMAIL</b></b-button
          >
        </div>
        <div class="column columns">
          <b-button type="is-light" :icon-right="getIconOrder('o.code')" expanded @click="tri('o.code')"
            ><b>ORGANISME</b></b-button
          >
        </div>
        <div class="column columns">
          <b-button
            type="column is-light is-half"
            :icon-right="getIconOrder('reponse')"
            expanded
            @click="tri('reponse')"
            ><b>REPONSE</b></b-button
          >
          <b-button
            type="column is-light is-half"
            :icon-right="getIconOrder('createdDate')"
            expanded
            @click="tri('createdDate')"
            ><b>DATE</b></b-button
          >
        </div>
      </div>
    </div>
    <mt-list v-slot="{ item: reponse }" :list="filteredUtil()">
      <mt-list-item>
        <div class="columns is-vcentered">
          <div class="columns column mt-marginless-bottom">
            <div class="column is-narrow icone">
              <mt-utilisateur :utilisateur="reponse.utilisateur"> </mt-utilisateur>
            </div>
          </div>
          <div class="column">
            {{ reponse.utilisateur.email }}
          </div>
          <div class="column columns">
            <div class="column">
              {{ reponse.utilisateur.affectation.organisme.code }}
            </div>
            <div v-if="reponse.utilisateur.affectation.organisme.codeParent" class="column">
              ({{ reponse.utilisateur.affectation.organisme.codeParent }})
            </div>
          </div>
          <div class="columns column">
            <div class="column has-text-right is-uppercase">
              <b>{{ reponse.reponse }}</b>
            </div>
            <div class="column has-text-right is-uppercase">
              {{ formatDate(reponse.createdDate) }}
            </div>
          </div>
        </div>
      </mt-list-item>
    </mt-list>
    <b-pagination
      :total="total"
      :current="pageCourante"
      :per-page="parPage"
      order="is-centered"
      aria-next-label="Utilisateurs suivants"
      aria-previous-label="Utilisateurs précedents"
      aria-page-label="Utilisateurs"
      aria-current-label="Page courante"
      @change="getReponses"
    />
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import userMixin from '~/components/mixins/userMixin';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtUtilisateur,
  },
  mixins: [userMixin],
  computed: {
    filteredOrganismeArray() {
      const organismesRet = [];
      this.organismes.forEach((brigade) => {
        if (this.estRecherche(brigade)) {
          if (this.isAdminBrigade) {
            organismesRet.push(brigade);
          }
        }
        brigade.organismesEnfants.forEach((regiment) => {
          if (this.estRecherche(regiment)) {
            organismesRet.push(regiment);
          }
          regiment.organismesEnfants.forEach((unite) => {
            if (this.estRecherche(unite)) {
              organismesRet.push(unite);
            }
          });
        });
      });
      return organismesRet;
    },
  },
  async asyncData(context) {
    const { idOrganisme } = context.params;
    let organismeSearch = '';
    let mOrganisme = null;
    const pageCourante = 1;
    const parPage = 20;
    const sortBy = 'ut.nom';
    const order = 'ASC';
    const filtreNom = '';
    const oldFiltre = '';
    const filtreReponse = '';
    const mapTri = new Map();
    mapTri.set('ut.nom', 'sort-ascending');
    mapTri.set('ut.prenom', 'none');
    mapTri.set('ut.email', 'none');
    mapTri.set('o.code', 'none');
    mapTri.set('reponse', 'none');
    mapTri.set('createdDate', 'none');
    mapTri.set('pr.code', 'none');
    const sondage = await context.$api.sondage.dernierSondage();
    const reponsesPossibles = await context.$api.sondage.reponsesPossibles();
    const organismes = await context.$api.organismes.allHiearchie();
    if (idOrganisme != null) {
      mOrganisme = await context.$api.organismes.get(idOrganisme);
      organismeSearch = mOrganisme.code;
    }
    const req = context.$api.sondage.allReponsesSort(
      idOrganisme,
      pageCourante - 1,
      parPage,
      sortBy,
      order,
      filtreNom,
      filtreReponse,
    );
    const { content: reponses, totalElements: total, numberOfElements: nombrePageCourante } = await req;

    return {
      reponses,
      filtreReponse,
      reponsesPossibles,
      sondage,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      monUtilisateur: null,
      sortBy,
      order,
      filtreNom,
      oldFiltre,
      mapTri,
      organismes,
      mOrganisme,
      organismeSearch,
    };
  },
  methods: {
    formatDate(date) {
      return DateTime.fromISO(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy');
    },
    async getReponses(page) {
      this.pageCourante = page;
      let req = null;
      if (this.mOrganisme != null) {
        req = this.$api.sondage.allReponsesSort(
          this.mOrganisme.id,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.filtreReponse,
        );
      } else {
        req = this.$api.sondage.allReponsesSort(
          null,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.filtreReponse,
        );
      }
      ({ content: this.reponses, totalElements: this.total, numberOfElements: this.nombrePageCourante } = await req);
    },
    filteredUtil() {
      if (this.filtreNom !== this.oldFiltre) {
        this.oldFiltre = this.filtreNom;
        this.getReponses(1);
      }
      return this.reponses;
    },
    reload() {
      this.getReponses(this.pageCourante);
    },
    tri(ordreTri) {
      this.mapTri.forEach(function tri(value, key) {
        if (key === ordreTri) {
          if (value === 'none') {
            this.sortBy = key;
            this.order = 'ASC';
            this.mapTri.set(key, 'sort-ascending');
          } else if (this.order === 'ASC') {
            this.order = 'DESC';
            this.mapTri.set(key, 'sort-descending');
          } else {
            this.order = 'ASC';
            this.mapTri.set(key, 'sort-ascending');
          }
        } else {
          this.mapTri.set(key, 'none');
        }
      }, this);
      this.getReponses(this.pageCourante);
    },
    getIconOrder(ordreTri) {
      return this.mapTri.get(ordreTri);
    },
    estRecherche(organisme) {
      return (
        organisme.code
          .toString()
          .toLowerCase()
          .includes(this.organismeSearch.toLowerCase()) ||
        organisme.libelle
          .toString()
          .toLowerCase()
          .includes(this.organismeSearch.toLowerCase())
      );
    },
    organismeChange() {
      if (this.organismeSearch === '') {
        this.mOrganisme = null;
        this.getReponses(1);
      }
    },
    async getUtilisateursOrganisme(organisme) {
      this.pageCourante = 1;
      if (organisme !== null) {
        this.mOrganisme = organisme;
        ({
          content: this.reponses,
          totalElements: this.total,
          numberOfElements: this.nombrePageCourante,
        } = await this.$api.sondage.allReponsesSort(
          organisme.id,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.filtreReponse,
        ));
      } else {
        this.mOrganisme = null;
        this.getReponses(1);
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-marginless-bottom {
  margin-bottom: 0;
}
/deep/ .radioButton input {
  visibility: hidden;
  & ~ .control-label {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;
    display: flex;
    align-items: center;

    .icon {
      margin-right: 0.8em;
    }
  }

  &:checked ~ .control-label,
  & ~ .control-label:hover {
    border-color: $soft-blue;
    background-color: $soft-blue;
    color: $white;
  }

  & + .check {
    display: none !important;
    visibility: hidden;
  }
}
/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
.visibility {
  visibility: hidden;
}
.button.is-light {
  border: 1px solid $primary;
  color: $primary;
}
</style>
